(function ($) {

  /**
   * Instagram File Picker (popup window).
   */

  // Get child element button.
  // This is the button that tirggered the popup.
  var instaButton = window.opener.document.getElementsByClassName('window-id-' + window.self.name);

  var selected = [];

  // Get button attributes.
  var _max_filesize = $(instaButton).data('max-filesize');
  var _description = $(instaButton).data('description');
  var _cardinality = $(instaButton).data('cardinality');
  var _multiselect = $(instaButton).data('multiselect');

  // Select photos.
  $('#photos a.photo').on('click', function(e) {
    var _photo_index = $(this).data('index');
    if (!isInArray(_photo_index, selected)) {
      selected.push(_photo_index);
      $(this).addClass('selected');
    }
    else {
      var remove_index = selected.indexOf(_photo_index);
      selected.splice(remove_index, 1);
      $(this).removeClass('selected');
    }
    if (selected.length > 0) {
      var selected_message;
      if (selected.length == 1) {
        selected_message = '<strong>' + selected.length + '</strong> file selected';
      }
      else {
        selected_message = '<strong>' + selected.length + '</strong> files selected';
      }
      $('#count').html(selected_message);
    }
    else {
      $('#count').html('');
    }
    e.preventDefault();
  });

  // Insert into field.
  $('a#pick').on('click', function(e) {
    if (selected.length) {
      var _files = [];
      for (var i = 0; i < selected.length; i++) {
        _files.push($('#photos a[data-index="' + selected[i] + '"]').data('standard-img'));
      }
      $('#files').html(_files.join('|'));
    }
    window.self.close();
    e.preventDefault();
  });

  $('#cancel').on('click', function(e) {
    window.self.close();
    e.preventDefault();
  });

  // Check if element is already in array.
  function isInArray(value, array) {
    return array.indexOf(value) > -1;
  }

}(jQuery));
